// C Header File
// Created 2001-06-22; 12:05:53

//Get player location
void get_location(int dir,int map_height)
{
	int temp=0;
	// Get the mapX 
	while (temp<31) {
		if (dir==1) {
			if (player_x>(temp*8)) mapx=temp;	
		}
		if (dir==2) {
			if (player_x>(temp*8-1)) mapx=temp;
		}
		temp++;
	}
	temp=0;
	while (temp<35) {
		if (player_y>temp*8) mapy=temp;
		temp++;
	}
	mapy+=map_height+2;
	mapx++;
}

void draw_map(int map_height) 
{
	int x=0;
	int y=map_height;
static unsigned char block_dark[] = {0x7E,0xC3,0x81,0x81,0x81,0x81,0xC3,0x7E};
static unsigned char block_light[] = {0x7E,0xC3,0x9F,0xBF,0xBF,0xFF,0xFF,0x7E};
//static unsigned char placeable_block[] = {0x7E,0x81,0xB1,0xA1,0x81,0x81,0x81,0x7E};
static unsigned char monster_light[] = {0x7E,0xFF,0xFF,0xFF,0x7E,0x7E,0x3C,0x00};
static unsigned char monster_dark[] = {0x7E,0x81,0xA5,0x81,0x5A,0x42,0x3C,0x66};
static unsigned char brick_light[] = {0xFC,0xFC,0xDC,0xFF,0x0F,0x1F,0xBF,0xFF};
static unsigned char brick_dark[] = {0x83,0x83,0xA3,0xFF,0xF8,0xE8,0x48,0xFF};
// special Block set.. can't be stand alone..
static unsigned char spblock_l_light[] = {0x7F,0xFF,0xFF,0xF0,0xF5,0xFF,0xFF,0x7F};  // Light (5)
static unsigned char spblock_l_dark[] = {0x7F,0x80,0x8F,0x9A,0x90,0x8F,0x80,0x7F};  // Dark
static unsigned char spblock_r_light[] = {0xFE,0xFF,0xFF,0xAF,0x0F,0xFF,0xFF,0xFE}; // (6)
static unsigned char spblock_r_dark[] = {0xFE,0x01,0xF1,0x09,0x59,0xF1,0x01,0xFE};
static unsigned char spblock_s_light[] = {0xFF,0xFF,0xFF,0xAA,0x00,0xFF,0xFF,0xFF}; // (7)
static unsigned char spblock_s_dark[] = {0xFF,0x00,0xFF,0x00,0x55,0xFF,0x00,0xFF};
// Special Block set #2, thin blocks
static unsigned char thin_l_light[] = {0x00,0x00,0x7F,0xD7,0x80,0x7F,0x00,0x00};  // (8)
static unsigned char thin_l_dark[] = {0x00,0x00,0x7F,0xA8,0xFF,0x7F,0x00,0x00};
static unsigned char thin_s_light[] = {0x00,0x00,0xFF,0xFF,0x00,0xFF,0x00,0x00};	// (9)
static unsigned char thin_s_dark[] = {0x00,0x00,0xFF,0x00,0xFF,0xFF,0x00,0x00};
static unsigned char thin_r_light[] = {0x00,0x00,0xFE,0xEB,0x01,0xFE,0x00,0x00};  // (10)
static unsigned char thin_r_dark[] = {0x00,0x00,0xFE,0x15,0xFF,0xFE,0x00,0x00};
//Some textures by MS (metal ground, a replacement placeable block)
static unsigned char metal_light[]={0xFF,0x00,0xFF,0x7E,0x18,0xBD,0xC3,0xDB}; //11
static unsigned char metal_dark[]={0xFF,0xFF,0x00,0xFF,0xFF,0xDB,0xFF,0xFF};
static unsigned char placeable_block_light[]={0x7E,0x81,0xBD,0xA5,0xA5,0xBD,0x81,0x7E}; //2
static unsigned char placeable_block_dark[]={0x7E,0xFF,0xC3,0xC3,0xC3,0xC3,0xFF,0x7E}; 

// special block #2
static unsigned char spblock2_light[] = {0xFF,0x00,0xFF,0x7E,0x7E,0xFF,0x00,0xFF};  // light (12)
static unsigned char spblock2_dark[] = {0xFF,0xFF,0xC3,0x66,0x66,0xC3,0xFF,0xFF}; // dark

	while (y<(map_height+15))
	{
		switch (map_array[y][x]) {
		case 1:	
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, block_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, block_light, GetPlane (LIGHT_PLANE));
		break;
		case 2:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, placeable_block_light, GetPlane (LIGHT_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, placeable_block_dark , GetPlane (DARK_PLANE));
		break;
		case 3:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, monster_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, monster_light, GetPlane (LIGHT_PLANE));
			map_array[y][x]=0;  // If this line is commented, new monsters will spawn each time you drop down to their level, or the level scrolls!
			monster_array[monster_count][0]=x*8;
			monster_array[monster_count][1]=(y-map_height+1)*8;
			monster_array[monster_count][2]=RIGHT;     // RIGHT by default
			monster_count++; // If we can view another monster.. make's sure it doesn't overwrite the current one ;)
		break;
		case 4:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, brick_dark, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, brick_light, GetPlane (LIGHT_PLANE));
		break;
		case 5:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_l_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_l_dark, GetPlane (LIGHT_PLANE));
		break;
		case 6:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_s_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_s_dark, GetPlane (LIGHT_PLANE));
		break;
		case 7:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_r_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock_r_dark, GetPlane (LIGHT_PLANE));
		break;
		case 8:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_l_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_l_dark, GetPlane (LIGHT_PLANE));
		break;
		case 9:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_s_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_s_dark, GetPlane (LIGHT_PLANE));
		break;
		case 10:
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_r_light, GetPlane (DARK_PLANE));
			Sprite8_XOR(x*8, (y-map_height+1)*8, 8, thin_r_dark, GetPlane (LIGHT_PLANE));
		break;
		case 11:
		Sprite8_XOR(x*8, (y-map_height+1)*8, 8, metal_dark, GetPlane (DARK_PLANE));
		Sprite8_XOR(x*8, (y-map_height+1)*8, 8, metal_light, GetPlane (LIGHT_PLANE));
		break;
		case 12:
		Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock2_dark, GetPlane (DARK_PLANE));
		Sprite8_XOR(x*8, (y-map_height+1)*8, 8, spblock2_light, GetPlane (LIGHT_PLANE));
		break;
		}
		x++;
		if (x>29) {
			x=0;
			y++;
		}		
	}
}


void intro_map(void)
{
	int y=0;
	int x=0;
		static unsigned char block_dark[] = {0x7E,0xC3,0x81,0x81,0x81,0x81,0xC3,0x7E};
	static unsigned char block_light[] = {0x7E,0xC3,0x9F,0xBF,0xBF,0xFF,0xFF,0x7E};


	static unsigned char placeable_block[] = {0x7E,0x81,0xB1,0xA1,0x81,0x81,0x81,0x7E};
	
	int intromap[10][31] = {{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1}, {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1}, {1,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1}, {1,2,2,0,0,0,0,0,0,0,0,0,0,1,2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1}, {1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,1}, {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,1}, {1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,1}, {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
 
ClearGrayScreen();
  
	while (y<9)
	{
		if (intromap[y][x]==1) {
			Sprite8(x*8, y*8+56, 8, block_dark, GetPlane (DARK_PLANE), SPRT_OR);
			Sprite8(x*8, y*8+56, 8, block_light, GetPlane (LIGHT_PLANE), SPRT_OR);
		}
		if (intromap[y][x]==2) {
			Sprite8(x*8, y*8+56, 8, placeable_block, GetPlane (DARK_PLANE), SPRT_OR);
		}
		x++;
		if (x>29) {
			x=0;
			y++;
		}		
	}
}
