// C Header File
// Created 7/10/2001; 12:15:33 PM
//Most of this thanks to John David Ratliff
#define FOLDER        $(jes)
#define READMODE "rb"
#define ARROWS_ROW 0xfffe      // Constants for low-level keyboard access
#define LEFT_KEY 16
#define RIGHT_KEY 64
#define UP_KEY 32
#define DOWN_KEY 128
#define SECOND_KEY 1
#define ESC_ROW 0xfeff
#define ESC_KEY 64
#define FCHK 16
#define ENTER1_ROW ~((short)(1 << 6))
#define ENTER1_KEY (1 << 6)
#define ENTER2_ROW ~((short)(1 << 9))
#define ENTER2_KEY (1 << 1)
//Grayscale screen buffers
void *vlight = NULL;
void *vdark = NULL;
enum        FileConstants        {HOWMANY = 50, MAXLEN = 9};

short int isMyType(const char *filename, const char *mytype) {
        FILE *f = fopen(filename,"rb");
        unsigned char ftype;
        char type[5];
        short int yes = 0;
        
        fseek(f,-1,SEEK_END); // go to the file tag
        ftype = (unsigned char)fgetc(f);
                
        if (ftype == OTH_TAG) { // do we have an other-type file
                // we're now at SEEK_END
                fseek(f,-6,SEEK_CUR);
                
                if (getc(f) != 0) {
                        fseek(f,-1,SEEK_CUR);
                }
                
                fread(type,5,1,f);
                
                if (strcmp(type,mytype) == 0) {
                        yes = 1;
                }
        }

fclose(f);
        
        return yes;
}

short int findAllFiles(char *buffer, const char *mytype, short int max) {
        short int counter = 0;
        SYM_ENTRY *SymPtr;

        SymPtr = SymFindFirst (FOLDER, 1);
        while (SymPtr && counter < max) {
                if (isMyType(SymPtr->name, mytype)) {
                        strcpy(buffer+(counter * MAXLEN), SymPtr->name);
                        counter++;
                }
                
                SymPtr = SymFindNext();
        }
        
        return counter;
}


void levsplash (char *filetitle, char *fileauthor)
{
int a;
unsigned char monster_light[] = {0x7E,0xFF,0xFF,0xFF,0x7E,0x7E,0x3C,0x00};
unsigned char monster_dark[] = {0x7E,0x81,0xA5,0x81,0x5A,0x42,0x3C,0x66};
unsigned char player_left_dark[] = 
		{0x7C,0x62,0x4A,0xC9,0xA2,0x9C,0x3C,0x76,0x76,0xFB,0xFF,0xFE,0x38,0x38,0x3C,0x3C};
unsigned char player_left_light[] = 
		{0x00,0x00,0x00,0x00,0x00,0x00,0x3C,0x76,0x76,0xFB,0xFF,0xFE,0x00,0x00,0x00,0x00};

	ClearGrayScreen2B(vlight,vdark);
	FloodFillMF (0,0,0x6BD6,vlight);
	FloodFillMF (0,0,0x6E73,vdark);
	FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
	FastCopyScreen(vdark,GetPlane(DARK_PLANE));
DrawGrayRect(0,0,239,30,COLOR_WHITE,RECT_FILLED);
DrawGrayRect(100,50,140,80,COLOR_WHITE,RECT_FILLED); 
Sprite8_OR(110,57,16,player_left_dark,GetPlane(DARK_PLANE));
Sprite8_OR(110,57,16,player_left_light,GetPlane(LIGHT_PLANE));
Sprite8_OR(122,65,8,monster_dark,GetPlane(DARK_PLANE));
Sprite8_OR(122,65,8,monster_light,GetPlane(LIGHT_PLANE));
FontSetSys(F_6x8);
for (a=0;a<2;a++)
{  SetPlane(a);	
	printf_xy (0,4,"%s",filetitle);
	printf_xy (0,14,"%s",fileauthor);

}
delay(950000);
}


char loadlev(char map_array[37][30],char *filetitle,char *fileauthor)
{
        const char *mytype = "jump";
        char *buffer = NULL;
        short int loop, total;
        short int y=24;
        int nerr,a,b;
        int locstop=0;
        int offset=0;
        int count=0;

unsigned char menu_pointer[] = {0x00,0x7C,0x62,0x4A,0xC9,0xA2,0x9C,0x00};
unsigned char pointclear[] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};
char load2(char *str,char whichtime)
{   
   FILE *f = fopen(str,READMODE);
short int n;
if (f != NULL) {
	
n = fread(map_array,sizeof(unsigned char),37*30,f);
if (n != 37*30) {
if (n != 1057) {

	FontSetSys (F_6x8);
DrawGrayStr(1,1,"Error...",A_REVERSE);
DrawGrayStr(1,11,"Loading internal levels...",A_REVERSE);

delay(300000);
FontSetSys (F_8x10);
return 0;}
fclose(f);
ClearGrayScreen();MoveTo(0,0);
FontSetSys (F_6x8);
printf("This is an old map...\nIt doesn't have author or\ntitle info. If this\nis your map, add\nthis info in JJedit.");
strcpy(filetitle,"No Title");
strcpy(fileauthor,"No Author");
for(a=35;a<37;a++)
{
	for (b=0;b<30;b++)
	{
		map_array[b][a] = 0;
	}
}
delay(700000);
levsplash(filetitle,fileauthor);
return 1;
}
fclose(f);
b=0;
while (map_array[35][b])
{
	*(filetitle+b) = map_array[35][b];
	b++;
}
*(filetitle+b+1) = '\0';

b=0;
while (map_array[36][b])
{
	*(fileauthor+b) = map_array[36][b];
	b++;
}
*(fileauthor+b+1) = '\0';

if(whichtime==1) return 1;
levsplash(filetitle,fileauthor);
return 1;
} else {
	FontSetSys (F_6x8);
DrawGrayStr(1,1,"Error...",A_REVERSE);
DrawGrayStr(1,11,"Loading internal levels...",A_REVERSE);
delay(300000);
FontSetSys (F_8x10);
return 0;
}
}
void typelevs(int y1)
{loop = offset;
	count=0;
	FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
	FastCopyScreen(vdark,GetPlane(DARK_PLANE));
Sprite8_AND(83,24,8,pointclear,GetPlane(0));
Sprite8_AND(83,24,8,pointclear,GetPlane(1));
Sprite8_AND(83,105,8,pointclear,GetPlane(0));
Sprite8_AND(83,105,8,pointclear,GetPlane(1));
Sprite8_OR(83,y1,8,menu_pointer,GetPlane(0));
Sprite8_OR(83,y1,8,menu_pointer,GetPlane(1));

      FontSetSys (F_6x8);
        for(loop = offset;loop<total;loop++)
        {
        	SetPlane(0);
        	printf_xy(93,y,"%s",buffer+(loop*MAXLEN));
        	 	SetPlane(1);
        	printf_xy(93,y,"%s",buffer+(loop*MAXLEN));
        	y+=9;
        	count++;
        	if(count>9) break;  
        }
        loop = offset;
}
FolderCur($(jes),FALSE);
        buffer = calloc(HOWMANY * MAXLEN,sizeof(char));
        
        total = findAllFiles(buffer,mytype,HOWMANY);

	FloodFillMF (0,0,0x6BD6,vlight);
	FloodFillMF (0,0,0x6E73,vdark);
   DrawGrayRect2B(80,22,157,115,COLOR_WHITE,RECT_FILLED,vlight,vdark);
        if(total != 0){
typelevs(24);
        y=24;
        loop=0;
        Sprite8_OR(83,y,8,menu_pointer,GetPlane(LIGHT_PLANE));
        Sprite8_OR(83,y,8,menu_pointer,GetPlane(DARK_PLANE));
        while (locstop==0)
        {
        		if (_rowread(ARROWS_ROW)&DOWN_KEY)
        		{
        		if (y==(9*count+15))
        		{if (loop==total-1); 
        		else {offset+=10;y=24;
        			if(total-offset<0) offset-=10;
        			typelevs(24); y=24;delay(50000);}
        		}
        		
        			else {y+=9;loop++;
        			Sprite8(83,y,8,menu_pointer,GetPlane(0),SPRT_OR);
        			Sprite8(83,y,8,menu_pointer,GetPlane(1),SPRT_OR);
        			Sprite8_AND(83,y-9,8,pointclear,GetPlane(0));
					Sprite8_AND(83,y-9,8,pointclear,GetPlane(1));
        			delay(75000);}
        		}
        		if (_rowread(ARROWS_ROW)&UP_KEY)
        		{
        			if (y==24)
        			{
        			if(loop!=0){offset-=10;y=24;
        			typelevs(105); y=105;loop=offset+9;delay(75000);}
        			}
        			else if (loop!=0) {y-=9;loop--;
        			Sprite8(83,y,8,menu_pointer,GetPlane(0),SPRT_OR);
        			Sprite8(83,y,8,menu_pointer,GetPlane(1),SPRT_OR);
        			Sprite8_AND(83,y+9,8,pointclear,GetPlane(0));
					Sprite8_AND(83,y+9,8,pointclear,GetPlane(1));
        			delay(75000);}
        		}
        		if (_rowread(ENTER1_ROW)&ENTER1_KEY || _rowread(ENTER2_ROW)&ENTER2_KEY) locstop=1;
        }

 //  FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
//	FastCopyScreen(vdark,GetPlane(DARK_PLANE));
strcpy(filestr,buffer+(loop*MAXLEN));
        nerr = load2(buffer+(loop*MAXLEN),0);
}
        if (total==0){ 
        	FastCopyScreen(vlight,GetPlane(LIGHT_PLANE));
	FastCopyScreen(vdark,GetPlane(DARK_PLANE));
        	FontSetSys(F_6x8);
        	DrawGrayStr(42,48,"ERROR:",A_NORMAL);
        	DrawGrayStr(42,58,"There aren't",A_NORMAL);
        	DrawGrayStr(42,68,"any external",A_NORMAL);
        	DrawGrayStr(42,78,"levels...",A_NORMAL);
        	nerr = 0;
        	delay(550000);
        }
        free(buffer);
        return nerr;
}

